package ru.ulstu.extractor.heuristic.api;

import ru.ulstu.extractor.heuristic.model.BuildTool;
import ru.ulstu.extractor.heuristic.model.ProgrammingLanguage;
import ru.ulstu.extractor.heuristic.model.StructuralUnit;
import ru.ulstu.extractor.heuristic.service.DetectorService;

import java.util.List;
import java.util.Optional;

public abstract class StructuralUnitIdentifier {
    public abstract List<StructuralUnit> getEntityClasses();

    public abstract List<StructuralUnit> getBusinessLogicClasses();

    public abstract boolean isMultiModuleProject();

    public abstract BuildTool getBuildTool();

    protected abstract DetectorService getDetectorService();

    protected abstract ProgrammingLanguage getProgrammingLanguage();

    public Optional<ProgrammingLanguage> getMainProgrammingLanguage() {
        String detectedLanguage = getDetectorService().getDetectedLanguage("package ru.ulstu.extractor.heuristic.service;");
        ProgrammingLanguage programmingLanguage = getProgrammingLanguage();
        return programmingLanguage.getName().equals(detectedLanguage)
                ? Optional.of(programmingLanguage)
                : Optional.empty();
    }

    public abstract boolean canAppliedToProject();
}
