package ru.ulstu.extractor.heuristic.service;

import org.springframework.stereotype.Service;
import ru.ulstu.extractor.heuristic.api.StructuralUnitIdentifier;
import ru.ulstu.extractor.heuristic.model.BuildTool;
import ru.ulstu.extractor.heuristic.model.JavaProgrammingLanguage;
import ru.ulstu.extractor.heuristic.model.ProgrammingLanguage;
import ru.ulstu.extractor.heuristic.model.StructuralUnit;

import java.util.List;

@Service
public class JavaIdentifier extends StructuralUnitIdentifier {

    private final DetectorService detectorService;

    public JavaIdentifier(DetectorService detectorService) {
        this.detectorService = detectorService;
    }

    @Override
    public boolean canAppliedToProject() {
        return /*getBuildTool() instanceof GradleBuildTool
                &&*/ getMainProgrammingLanguage().orElse(null) instanceof JavaProgrammingLanguage;
    }

    @Override
    public List<StructuralUnit> getEntityClasses() {
        return null;
    }

    @Override
    public List<StructuralUnit> getBusinessLogicClasses() {
        return null;
    }

    @Override
    public boolean isMultiModuleProject() {
        return false;
    }

    @Override
    public BuildTool getBuildTool() {
        return null;
    }

    @Override
    protected DetectorService getDetectorService() {
        return detectorService;
    }

    @Override
    protected ProgrammingLanguage getProgrammingLanguage() {
        return new JavaProgrammingLanguage();
    }
}
